#include <stdio.h>
#include <stdlib.h>
#include <iostream.h>
#include <math.h>

#include "typedefs.h"

#include "file.h"

class   BitStream {
public:
int     BitPos,
        BitsLeft;
BYTE    WorkByte;
BYTE    *Stream;

BitStream(BYTE *_Stream) {
    Stream=_Stream;
    BitPos=0;
    BitsLeft=0;
    }

int GetSingleBit()
    {
    if(!BitsLeft) {
        WorkByte=*Stream++;
        BitsLeft=8;
        }
    int b=WorkByte>>7;
    BitsLeft--;
    WorkByte=(WorkByte<<1) & 0xFFFFFFFF;
    return(b);
    }

int GetBits(int NumBits)
    {
    int b=0;
    for(int i=0; i<NumBits; i++)
        b=(b<<1)|GetSingleBit();
    return(b);
    }

void    PutSingleBit(int b)
    {
    if(BitsLeft==8) {
        Stream++;
        //*Stream=0;
        BitsLeft=0;
        }

    //*Stream=((*Stream)<<1)|(b & 0x1);
    *Stream=((*Stream) & (~(1<<(7-BitsLeft))))|((b & 1)<<(7-BitsLeft));
    //*Stream=(*Stream)|((b & 1)<<(7-BitsLeft));
    BitsLeft++;
    }

void    PutBits(int b, int NumBits)
    {
    for(int i=0; i<NumBits; i++)
        PutSingleBit((b>>(NumBits-1-i)) & 1);
    }
};


int MyLog2(int Val)
    {

    return(ceil(log2(Val)));
    }

// c bbbbbbbb
// c lllloooo oooooooo

int     Compress(BitStream is, BitStream os, int is_size)
    {
    int     os_bitsize=0;
    BYTE    *isp=(BYTE *)is.Stream;
    int     i=0;
    while(i<is_size) {
        // Get a complete byte from the input stream
        int b=isp[i];
        
        // Try to find a match:
        int MaxMatchSize=0,
            MaxMatchPos=-1;

        if((is_size-i)>2)
        for(int j=0; j<(i-2); j++) {
            if(isp[j]==isp[i]) {
                for(int k=0; (k<128) && ((j+k)<i) && (isp[j+k]==isp[i+k]); k++);
                if(k>MaxMatchSize) {
                    MaxMatchSize=k;
                    MaxMatchPos=j;}

                 }
            }

        // Output either raw byte or reference
        if(MaxMatchSize>=2) {
            /*os.PutBits(1, 1);
            os.PutBits((MaxMatchSize-1),4);
            os.PutBits(i-MaxMatchPos, 12);
            i+=MaxMatchSize;
            os_bitsize+=17;*/


//  Value      Encoding       Range     Gained
//  0000000    not possible
//  0000001    0              1         -6 bits
//  000001x    10x            2-3       -4 bits: 2-3  -> 0-1 (-2) (1<<NZ)
//  00001xx    110xx          4-7       -2 bits: 4-7  -> 0-3 (-4) (1<<NZ)
//  0001xxx    1110xxx        8-15      +0 bits: 8-15 -> 0-7 (-8) (1<<NZ)
//  001xxxx    11110xxxx      16-31     +2 bits
//  01xxxxx    111110xxxxx    32-63     +4 bits
//  1xxxxxx    111111xxxxxx   64-127    +5 bits

            {
            os.PutBits(1, 1);
            // Make Elias Gamma Code
            int NumZeroes=0,
                Range=1;
            while((Range*2-1)<(MaxMatchSize-1)) {
                NumZeroes++;
                Range<<=1;
                }
            if(NumZeroes)
                os.PutBits(0,NumZeroes);
            os.PutBits(1,1);  
            if(NumZeroes)
                os.PutBits((MaxMatchSize-1)-(1<<NumZeroes),NumZeroes);
            //os.PutBits(i-MaxMatchPos-1, 12);
            os.PutBits(i-MaxMatchPos-1, MyLog2(i+1));
            //os_bitsize+=1+NumZeroes+1+NumZeroes+12;
            os_bitsize+=1+NumZeroes+1+NumZeroes+MyLog2(i+1);
            i+=MaxMatchSize;
            // cout << "Match! Size: " << MaxMatchSize << ". Pos: " << MaxMatchPos << ".\n";
            }

            }
        else {
            os.PutBits(0, 1);
            os.PutBits(b, 8);
            i++;
            os_bitsize+=9;
            }
        }
    return((os_bitsize+7)>>3);
    }

void    Uncompress(BitStream is, BYTE *decoded, int d_size)
    {
    int i=0;
    while(i<d_size) {
        int dflag=is.GetBits(1);
        if(dflag) {
            // Copy string from earlier decompressed data
            /*int Length=is.GetBits(4)+1,
                Pos=i-is.GetBits(12);
            for(int j=0; j<Length; j++) {
                decoded[i+j]=decoded[Pos+j];
                }
            i+=Length;*/



//  Value      Encoding       Range     Gained
//  0000000    not possible
//  0000001    0              1         -6 bits
//  000001x    10x            2-3       -4 bits: 2-3  -> 0-1 (-2) (1<<NZ)
//  00001xx    110xx          4-7       -2 bits: 4-7  -> 0-3 (-4) (1<<NZ)
//  0001xxx    1110xxx        8-15      +0 bits: 8-15 -> 0-7 (-8) (1<<NZ)
//  001xxxx    11110xxxx      16-31     +2 bits
//  01xxxxx    111110xxxxx    32-63     +4 bits
//  1xxxxxx    111111xxxxxx   64-127    +5 bits
            {
            // Read Elias Gamma Code
            int NumZeroes=0,
                Length=2,
                Pos,
                Bit;
            while(!(Bit=is.GetBits(1)))
                NumZeroes++;
                
            if(NumZeroes)
                Length=is.GetBits(NumZeroes)+(1<<NumZeroes)+1;
            //Pos=i-is.GetBits(12)-1;
            Pos=i-is.GetBits(MyLog2(i+1))-1;
            for(int j=0; j<Length; j++) {
                decoded[i+j]=decoded[Pos+j];
                }

            //os.PutBits(1,1);
            //os.PutBits((MaxMatchSize-1)-(1<<NumZeroes),NumZeroes);
            i+=Length;
            }


            }
        else {
            // Output raw data byte
            int b=is.GetBits(8);
            decoded[i]=b;
            i++;
            }
        }
    }

void    main(int argc, char *argv[])
    {
    int     InFileSize=get_filesize(argv[1]);
    BYTE    *InFile=new BYTE[InFileSize],
            *OutFile=new BYTE[InFileSize*2],
            *Decoded=new BYTE[InFileSize*2];

    if(argc!=4) {
        cout << "Syntax: C <raw data file> <compressed file> <uncompressed file>\n";
        exit(0);
        }

    readfile(argv[1],0,InFileSize,InFile);
    
    // readfile(argv[1],0,get_filesize(argv[1]),Image);

    BitStream   InStream(InFile),
                OutStream(OutFile+2);
    int OutFileSize=Compress(InStream, OutStream, InFileSize);
    Uncompress(OutStream, Decoded, InFileSize);
    OutFile[0]=InFileSize & 0xFF;
    OutFile[1]=(InFileSize>>8);

    writefile(argv[2],0,OutFileSize+2,OutFile);
    writefile(argv[3],0,InFileSize,Decoded);
    printf("Compressed size = %d\n",OutFileSize+2);
    }
