#include <stdio.h>
#include <stdlib.h>
#include <iostream.h>
#include <math.h>

#include "typedefs.h"

#include "file.h"


int     MakeDeltaNameTable(BYTE *Src, BYTE *Dest, int SrcSize)
    {
    int i=0, j, k=0;
    int PrevVal=0;
    while(i<SrcSize) {
        int Delta=Src[i]-PrevVal;

        for(j=0; ((i+j+1)<SrcSize) && ((Src[i+j+1]-Src[i+j])==Delta); j++);

        int Length=j+1;

        if(Length>256)
            Length=256;

        int CodeWord=(Length & 0xFF)+(Delta<<8);
        Dest[k]=CodeWord & 0xFF;
        Dest[k+1]=CodeWord>>8;
        k+=2;
        i+=Length;
        PrevVal=Src[i-1];
        }
    return(k);
    }

int UnpackDeltaNameTable(BYTE *Src, BYTE *Dest, int SrcSize)
    {
    WORD    *cwp=(WORD *)Src;
    int Val=0;
    int k=0;
    for(int i=0; i<(SrcSize>>1); i++) {
        int Delta=cwp[i]>>8,
            Length=cwp[i] & 0xFF;

        if(Length==0)
            Length=256;
        for(int j=0; j<Length; j++) {
            Val+=Delta;
            Dest[k+j]=Val;
            }
        k+=Length;
        }
    return(k);
    }

void    main(int argc, char *argv[])
    {
    int     InFileSize=get_filesize(argv[1]);
    BYTE    *InFile=new BYTE[InFileSize],
            *OutFile=new BYTE[InFileSize*2],
            *Decoded=new BYTE[InFileSize*2];

    if(argc!=4) {
        cout << "Syntax: DELTANAM <nametable file> <delta-nametable file> <unpacked file>\n";
        exit(0);
        }

    readfile(argv[1],0,InFileSize,InFile);
    
    // readfile(argv[1],0,get_filesize(argv[1]),Image);

    int OutFileSize=MakeDeltaNameTable(InFile, OutFile, InFileSize);
    int DecodedSize=UnpackDeltaNameTable(OutFile, Decoded, OutFileSize);
    writefile(argv[2],0,OutFileSize,OutFile);
    
    writefile(argv[3],0,DecodedSize,Decoded);
    printf("Compressed size = %d\n",OutFileSize);
    }
